Anonymous | Login
Project:
RSS
  
News | My View | View Issues | Roadmap | Summary

View Issue DetailsJump to Notes ] Issue History ] Print ]
ID
0038721
TypeCategorySeverityReproducibilityDate SubmittedLast Update
defect[Retail Modules] Web POSmajoralways2018-06-07 15:232018-06-11 09:01
ReporteraaroncaleroView Statuspublic 
Assigned Tomarvintm 
PriorityhighResolutionfixedFixed in VersionRR18Q3
StatusclosedFix in branchFixed in SCM revision23da3e33c5ce
ProjectionnoneETAnoneTarget Version
OSAnyDatabaseAnyJava version
OS VersionDatabase versionAnt version
Product VersionSCM revision 
Review Assigned Tomigueldejuana
Regression level
Regression date
Regression introduced in release
Regression introduced by commit
Triggers an Emergency PackNo
Summary

0038721: OutDatedDataChangeException thrown when modifying a ticket updated before a time change

DescriptionThe existing verification of concurrent modification of orders/layaways can fail if an order was modified for the last time before a time change (i.e. during Winter time) and now it is modified again from web pos (adding a new payment, etc).
The OrderLoader checks the following two values:
loaded = POSUtils.dateFormatUTC.parse(jsonorder.getString("loaded"));
updated = OBMOBCUtils.convertToUTC(order.getUpdated());

The loaded variable is converted correctly to the utc date, however the updated variable is converted taking into account the timezone offset of the current date
Steps To ReproduceLogin in web pos
Create a simple ticket with a product and pay it.
Change the updated value of the order in the database to a date in february (before the Daylight saving time change)
Load a ticket again in web pos.
Do a reverse payment (click on the total amount > click on reverse payment button > click on Ok) and complete the ticket payment again.
Click on Done.
Verify that the ticket has ended in Errors While importing POS Data window and that the cause of the error is an OutDatedDataChangeException.
Proposed SolutionThe OBMOBCUtils.convertToUTC method takes the date passed as an argument and adds 2 different offsets, the timezone offset and the DST offset, which are taken from the current date.
The DST offset should be taken from the date that is being converted to UTC.
TagsNo tags attached.
Attached Filesdiff file icon issue38721_posterminal.diff [^] (2,588 bytes) 2018-06-07 18:55 [Show Content]
diff file icon issue38721_mobile.core.diff [^] (1,252 bytes) 2018-06-07 18:55 [Show Content]

- Relationships Relation Graph ] Dependency Graph ]
depends on backport 0038727RR18Q2.1 closedmarvintm OutDatedDataChangeException thrown when modifying a ticket updated before a time change 

-  Notes
(0105033)
hgbot (developer)
2018-06-08 12:33

Repository: erp/pmods/org.openbravo.retail.posterminal
Changeset: d34b76741eac94f6eccbe744c170eda0132c4ba4
Author: Antonio Moreno <antonio.moreno <at> openbravo.com>
Date: Thu Jun 07 18:57:20 2018 +0200
URL: http://code.openbravo.com/erp/pmods/org.openbravo.retail.posterminal/rev/d34b76741eac94f6eccbe744c170eda0132c4ba4 [^]

Fixed issue 38721. OutDatedDataChangeException thrown when modifying a ticket updated before a time change.
'loaded' and 'updated' dates (both coming from server in the end) will be parsed and transformed in the same way, thus avoiding problems with timezones and daylight saving changes

---
M src/org/openbravo/retail/posterminal/ExternalOrderLoader.java
M src/org/openbravo/retail/posterminal/OrderLoader.java
M src/org/openbravo/retail/posterminal/ProcessVoidLayaway.java
---
(0105034)
hgbot (developer)
2018-06-08 12:33

Repository: erp/pmods/org.openbravo.retail.posterminal
Changeset: 15a099451f305959b219a7baeea6267727147d8f
Author: Antonio Moreno <antonio.moreno <at> openbravo.com>
Date: Fri Jun 08 12:33:14 2018 +0200
URL: http://code.openbravo.com/erp/pmods/org.openbravo.retail.posterminal/rev/15a099451f305959b219a7baeea6267727147d8f [^]

Related to issue 38721. Merge with pi

---
M src/org/openbravo/retail/posterminal/ExternalOrderLoader.java
M src/org/openbravo/retail/posterminal/OrderLoader.java
M src/org/openbravo/retail/posterminal/ProcessVoidLayaway.java
---
(0105035)
hgbot (developer)
2018-06-08 12:33

Repository: erp/pmods/org.openbravo.mobile.core
Changeset: 23da3e33c5ceb47d52616c32335a59095ed67146
Author: Antonio Moreno <antonio.moreno <at> openbravo.com>
Date: Thu Jun 07 18:57:29 2018 +0200
URL: http://code.openbravo.com/erp/pmods/org.openbravo.mobile.core/rev/23da3e33c5ceb47d52616c32335a59095ed67146 [^]

Fixed issue 38721. OutDatedDataChangeException thrown when modifying a ticket updated before a time change.
'loaded' and 'updated' dates (both coming from server in the end) will be parsed and transformed in the same way, thus avoiding problems with timezones and daylight saving changes

---
M src/org/openbravo/mobile/core/utils/OBMOBCUtils.java
---
(0105050)
migueldejuana (developer)
2018-06-11 09:01

Tested and reviewed

- Issue History
Date Modified Username Field Change
2018-06-07 15:23 aaroncalero New Issue
2018-06-07 15:23 aaroncalero Assigned To => Retail
2018-06-07 15:23 aaroncalero Triggers an Emergency Pack => No
2018-06-07 18:55 marvintm File Added: issue38721_posterminal.diff
2018-06-07 18:55 marvintm File Added: issue38721_mobile.core.diff
2018-06-08 12:33 hgbot Checkin
2018-06-08 12:33 hgbot Note Added: 0105033
2018-06-08 12:33 hgbot Status new => resolved
2018-06-08 12:33 hgbot Resolution open => fixed
2018-06-08 12:33 hgbot Fixed in SCM revision => http://code.openbravo.com/erp/pmods/org.openbravo.retail.posterminal/rev/d34b76741eac94f6eccbe744c170eda0132c4ba4 [^]
2018-06-08 12:33 hgbot Checkin
2018-06-08 12:33 hgbot Note Added: 0105034
2018-06-08 12:33 hgbot Checkin
2018-06-08 12:33 hgbot Note Added: 0105035
2018-06-08 12:33 hgbot Fixed in SCM revision http://code.openbravo.com/erp/pmods/org.openbravo.retail.posterminal/rev/d34b76741eac94f6eccbe744c170eda0132c4ba4 [^] => http://code.openbravo.com/erp/pmods/org.openbravo.mobile.core/rev/23da3e33c5ceb47d52616c32335a59095ed67146 [^]
2018-06-08 13:47 marvintm Assigned To Retail => marvintm
2018-06-08 13:50 marvintm Status resolved => new
2018-06-08 13:50 marvintm Resolution fixed => open
2018-06-08 13:50 marvintm Status new => acknowledged
2018-06-08 13:50 marvintm Status acknowledged => scheduled
2018-06-08 13:50 marvintm Status scheduled => resolved
2018-06-08 13:50 marvintm Fixed in Version => RR18Q3
2018-06-08 13:50 marvintm Resolution open => fixed
2018-06-11 09:01 migueldejuana Review Assigned To => migueldejuana
2018-06-11 09:01 migueldejuana Note Added: 0105050
2018-06-11 09:01 migueldejuana Status resolved => closed


Copyright © 2000 - 2009 MantisBT Group
Powered by Mantis Bugtracker